;  -*- scheme -*-

(document:surround "/std/frame")
(document:insert "/std/functions")

(document:insert "/vm/functions")

;----------------------------------------------------------------
(define (evms-open)
  (woo-catch/message
   (lambda()
     (woo-write "/evms/control" 'control 'open 'installer #t)
     (woo-write "/evms/control" 'control 'update))))

(define (current-profile)
  (string-append
   "/evms/profiles/"
   (car (woo-list-names "/evms/profiles"))))

(define (profile-apply)
  (woo 'apply (current-profile)
       'commit #t
       'clearall #t
       'exclude '()))

(define (profile-commit . args)
  (evms-with-splash
   (lambda()
     (woo-catch/message
      (lambda ()
        (woo-write "/evms/control" 'control 'commit)
        (apply woo-write "/evms/control" 'control 'close args))))))

;---------------------------------------------------------------
(define (dostuff)
  (let ((reply (profile-apply)))
    (format #t "<* ~S\n" reply)
    (cond
     ((eqv? (caar reply) #t)
      (let loop ((ret (profile-commit)))
        (format #t "RET: ~S\n" ret)
        (cond ((null? ret)             ; all went good
               #t)
              ((not ret)               ; fail
               (woo-write "/evms/control" 'control 'reset)
               'cancel)
              (#t                      ; show warn
               (case (document:popup-warning (cadar ret) 'cancel 'ok)
                 ((ok)                 ; ignore this warning
                  (loop (profile-commit 'ignore (caar ret))))
                 ((cancel)             ; let user fix things
                  (frame:replace '/vm/table 'installer #t)
                  'cancel))))))
     (#t
      (woo-write "/evms/control" 'control 'reset)
      (woo-write "/evms/control" 'control 'update)
      (document:popup-critical
       (apply string-append
              "<center><p><b>"
              (_ "Unable to partition, not enough disk space")
              "</b></p></center>"
              (map cadr reply)) 'ok)
      'cancel))))

;---------------------------------------------------------------

(label (_ "All data from all your disks will be lost!") align center)
(document:id chk (checkbox (_ "Yes, i'm warned") align center
                           (when toggled (frame:next-activity (chk state)))))

(document:root (when loaded
                 (evms-open)
                 (frame:next-activity #f)))

(frame:on-next dostuff)
