; $Id: popup.scm,v 1.6 2006/08/29 16:24:56 me Exp $ -*- scheme -*-

(document:surround "/std/frame")
(document:insert "/std/functions")

(document:insert "/vm/functions")

(document:envelop with-attributes (option set-value! has-value? got-value need-value apply-value))

(document:envelop with-container-presentations
                  ((option-widget '/vm/option option)))

;---------------------------------------------------------------
(define option-widgets (make-cell '()))
(define task-objects (make-cell '()))
(define lasthop (make-cell #f))
(define importance (make-cell #f))
(define verbosity (make-cell (caar (woo-read-task 'verbose))))

;---------------------------------------------------------------
(define (insert-objects)
  (and-let* ((objects (cond-car (woo-read-task 'objects))))
            (or (null? objects)
                (begin
                  (cell-set! task-objects objects)
                  (object-box checklist-rows objects)
                  (object-group visibility #t)))))

(define (commit-objects)
  (let ((active-objects (object-box checklist-active-rows)))
    (if (null? active-objects)
        (cont-button activity #f)
        (begin
          (cont-button activity (options-ready?))
          (woo-write-task 'set-objects! 'objects active-objects)))))

;---------------------------------------------------------------
(define (options-ready?)
  (every-widget has-value?))

(define (option-lasthop? option)
  (and (memq 'lasthop (assv-ref option 'flags)) #t))

(define (option-important? option)
  (and (memq 'important (assv-ref option 'flags)) #t))

(define (deep-any pred options)
  (apply (lambda (opt) (any pred opt)) options))

(define (every-widget . args)
  (every values (apply (apply widgets (cell-ref option-widgets)) args)))

(define (task-options)
  (let ((options (woo-read-task 'options)))
    (cell-set! importance (deep-any option-important? options))
    (cell-set! lasthop (deep-any option-lasthop? options))
    (and (global 'next-title)
         (op-next visibility (not (cell-ref lasthop))))
    (apply values options)))

(define (make-option-widget option)
  (option-widget
   option
   (when got-value (cont-button activity (options-ready?)))
   (when need-value (every-widget set-value! (task-options)))))

(define (make-option-widgets)
  (let ((ws (map make-option-widget (task-options))))
    (cell-set! option-widgets ws)
    (apply option-box ws)))

(define (insert-options)
  (clean-widget option-box make-option-widgets))

;---------------------------------------------------------------
(define (apply-task)
  (and (every-widget apply-value)
       (document:end
        (woo-write-task
         'apply
         'verbose  (and (global 'next-title) (verbose state))
         'next-hop (and (nexthop state) (not (cell-ref lasthop)))))))

(define (make-popup-title str)
  (string-append "<center><b>" (or (global 'title) "") "</b><center>" str))

;---------------------------------------------------------------
(document:id popup-title (label (make-popup-title "")))

(gridbox
 (document:id object-group
              (groupbox (_ "Objects") visibility #f
                        (document:id object-box (checklist checklist-rows '()
                                                           (when clicked (commit-objects))))))
 (document:id option-box
              (groupbox (_ "Options") visibility #t '()))

 (and (global 'next-title)
      (document:id op-next
                   (groupbox (_ "Next operation")
                             (gridbox columns "50;50"
                                      (document:id nexthop (checkbox (global 'next-title) state #t))
                                      (document:id verbose (checkbox (_ "Show extra options") state #f)))))))

(box
 orientation 'horizontal
 (document:id
  cont-button
  (button (_ "OK")
          activity #f
          (when clicked (apply-task))))
 (button (_ "Cancel")
         (when clicked
           (woo 'destroy (global 'task-path))
           (document:end '((cancel))))))

(when loaded
  (insert-objects)
  (insert-options)
  (cont-button activity (options-ready?))
  (cond
   ((and (null? (cell-ref option-widgets)) (null? (cell-ref task-objects)))
    ;; no options/objects at all -- pass thru
    ;; copy verbose flag to next stage, if any
    (and (global 'next-title) (verbose state (cell-ref verbosity)))
    (apply-task))
   ((or (cell-ref verbosity) (cell-ref importance))
    ;; has some important options or by user requst
    #t)
   ((options-ready?)
    ;; no important options,
    ;; rest of options with reasonable defaults
    (apply-task))))
